# Multi Providers - Login with Google or Microsoft

{% hint style="warning" %}
This approach is discouraged.

Instead of managing multiple authentication providers within your application, consider using [Keycloak](https://www.keycloak.org/) or [Auth0](https://auth0.com/) to streamline and centralize identity provider integration.
{% endhint %}

The example setup is live here: [https://example-multi-providers.oidc-spa.dev/](https://example-multi-providers.oidc-spa.dev)

Run it locally with:

```bash
npx degit https://github.com/keycloakify/oidc-spa/examples/multi-providers oidc-spa-multi-providers
cd oidc-spa-multi-providers
# NOTE: With this example only internat Insee Microsoft account can sign in.
# You can however signin with your personal Google Account.
cp .env.local.sample .env.local
yarn
yarn dev
```

{% embed url="<https://github.com/keycloakify/oidc-spa/tree/main/examples/multi-providers>" %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.oidc-spa.dev/docs/v6/setup-guides/multi-providers.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
